unit BreakDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TBreakpointForm = class(TForm)
    GroupBox1: TGroupBox;
    Memo: TMemo;
    GroupBox2: TGroupBox;
    List: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure ListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButtonWork(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BreakpointForm: TBreakpointForm;

implementation

uses MainUnit, InputDlg;

{$R *.DFM}

procedure TBreakpointForm.FormShow(Sender: TObject);
Var L : TStrings;
    X : Integer;
begin
  L:=MainForm.System8051.Programm.GetListing; Memo.Lines.Assign(L); L.Free;
  List.Clear;
  For X:=0 to MainForm.Breakpoints.Count-1 do List.Items.Add('0x'+IntToHex(Integer(MainForm.Breakpoints[X]),4));
  BitBtn6.Enabled:=not MainForm.Memo.ReadOnly;
end;

procedure TBreakpointForm.BitBtn4Click(Sender: TObject);
Var X : Integer;
begin
  MainForm.Breakpoints.Clear;
  For X:=0 to List.Items.Count-1 do MainForm.Breakpoints.Add(Pointer(StrToInt(List.Items[X])));
end;

procedure TBreakpointForm.ListKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
Var I : Integer;
begin
  Case Key of
    VK_Return : If List.ItemIndex>=0 then begin
                  I:=StrToInt(List.Items[List.ItemIndex]);
                  If InputNumber(I,2) then List.Items[List.ItemIndex]:='0x'+IntToHex(I,4);
                end;
    VK_Insert : begin
                  I:=0;
                  If InputNumber(I,2) then List.Items.Add('0x'+IntToHex(I,4));
                end;
    VK_Delete : If List.ItemIndex>=0 then List.Items.Delete(List.ItemIndex);
  end;

end;

procedure TBreakpointForm.ButtonWork(Sender: TObject);
Var Key : Word;
begin
  Case (Sender as TBitBtn).Tag of
    0 : Key:=VK_Insert;
    1 : Key:=VK_Return;
    2 : Key:=VK_Delete;
  end;
  ListKeyDown(Sender,Key,[]);
end;

procedure TBreakpointForm.BitBtn6Click(Sender: TObject);
Var L : TStrings;
begin
  If not MainForm.System8051.LoadCode(MainForm.Memo.Lines,False,MainForm.SetupData.AutoInterruptHandling) then begin
    MessageDlg('"'+MainForm.System8051.ErrorCode+'" in Zeile '+IntToStr(MainForm.System8051.ErrorLine),mtError,[mbOK],0);
    exit;
  end;
  L:=MainForm.System8051.Programm.GetListing; Memo.Lines.Assign(L); L.Free;
end;

end.
