unit Decompiler;
interface

uses Classes;

Function DecompileOp(const St : TStream; var AsmText : String) : Integer;
Function DecompilePrg(const St : TStream) : TStrings;

implementation

uses SysUtils, Tools, PrgConst;

Function DecompileStdFunction(PreText, PostText : String; const St : TStream; var AsmText : String) : Integer;
Var B : Byte;
begin
  result:=1;
  try
    St.Read(B,1); AsmText:=PreText+IntToHex(B,2)+PostText;
  except
    AsmText:='kein Parameter'; result:=0;
  end;
end;

Function DecompileStdFunction2(PreText, MiddleText, PostText : String; const St : TStream; var AsmText : String) : Integer;
Var B1,B2 : Byte;
begin
  result:=2;
  try
    St.Read(B1,1); St.Read(B2,1);
    AsmText:=PreText+IntToHex(B1,2)+MiddleText+IntToHex(B2,2)+PostText;
  except
    AsmText:='kein Parameter'; result:=0;
  end;
end;

Function DecompileLong(PreText : String; const St : TStream; var AsmText : String) : Integer;
Var B1,B2 : Byte;
    I : Integer;
begin
  result:=0;
  try St.Read(B1,1); except AsmText:='keine Parameter'; exit; end;
  try St.Read(B2,1); except AsmText:='keine Parameter'; exit; end;
  I:=B1; I:=I*256+B2; result:=2; AsmText:=PreText+IntToHex(I,4);
end;

Function GetRel(B : Byte) : String;
Var Sh : ShortInt;
begin
  Sh:=ShortInt(B);
  If Sh<0 then result:='-' else result:='+';
  result:=result+'0x'+IntToHex(Abs(Sh),2);
end;

Function DecompileBitFunction(PreText, PostText : String; const St : TStream; var AsmText : String) : Integer;
Var B : Byte;
    X : Integer;
    S : String;
begin
  result:=1;
  try
    St.Read(B,1); S:='';
    For X:=0 to AllTimeBitTab.Count-1 do If B=Integer(AllTimeBitTab.Objects[x]) then begin
      AsmText:=PreText+AllTimeBitTab[x]+PostText; exit;
    end;
    If S='' then
    For X:=0 to AllTimeTab.Count-1 do If CodeToBit(B)=Integer(AllTimeTab.Objects[X]) then begin
      S:=AllTimeTab[x]; break;
    end;
    If S='' then S:='0x'+IntToHex(CodeToBit(B),2);
    S:=S+'.'+IntToStr(B mod 8);
    AsmText:=PreText+S+PostText;
  except
    AsmText:='kein Parameter'; result:=0;
  end;
end;

Function DecompileBitFunction2(PreText, PostText : String; const St : TStream; var AsmText : String) : Integer;
Var B : Byte;
begin
  result:=DecompileBitFunction(PreText,PostText,St,AsmText);
  If result=0 then exit;
  result:=2;
  try
    St.Read(B,1); AsmText:=AsmText+GetRel(B);
  except
    AsmText:='kein Parameter'; result:=0;
  end;
end;


Function DecompileOp(const St : TStream; var AsmText : String) : Integer;
Var B,C : Byte;
begin
  result:=1;
  try St.Read(B,1); except AsmText:='keine Daten'; exit; end;
  Case B of
    $00 : AsmText:='nop';
    $01 : inc(result,DecompileStdFunction('ajmp (0x0',')',St,AsmText));
    $02 : inc(result,DecompileLong('ljmp 0x',St,AsmText));
    $03 : AsmText:='rr a';
    $04 : AsmText:='inc a';
    $05 : inc(result,DecompileStdFunction('inc 0x','',St,AsmText));
    $06 : AsmText:='inc @r0';
    $07 : AsmText:='inc @r1';
    $08 : AsmText:='inc r0';
    $09 : AsmText:='inc r1';
    $0A : AsmText:='inc r2';
    $0B : AsmText:='inc r3';
    $0C : AsmText:='inc r4';
    $0D : AsmText:='inc r5';
    $0E : AsmText:='inc r6';
    $0F : AsmText:='inc r7';
    $10 : inc(result,DecompileBitFunction2('jbc ',',',St,AsmText));
    $11 : inc(result,DecompileStdFunction('acall (0x0',')',St,AsmText));
    $12 : inc(result,DecompileLong('lcall 0x',St,AsmText));
    $13 : AsmText:='rrc a';
    $14 : AsmText:='dec a';
    $15 : AsmText:='dec dadr';
    $16 : AsmText:='inc @r0';
    $17 : AsmText:='inc @r1';
    $18 : AsmText:='dec r0';
    $19 : AsmText:='dec r1';
    $1A : AsmText:='dec r2';
    $1B : AsmText:='dec r3';
    $1C : AsmText:='dec r4';
    $1D : AsmText:='dec r5';
    $1E : AsmText:='dec r6';
    $1F : AsmText:='dec r7';
    $20 : inc(result,DecompileBitFunction2('jb ',',',St,AsmText));
    $21 : inc(result,DecompileStdFunction('ajmp (0x1',')',St,AsmText));
    $22 : AsmText:='ret';
    $23 : AsmText:='rl a';
    $24 : inc(result,DecompileStdFunction('add a,#0x','',St,AsmText));
    $25 : inc(result,DecompileStdFunction('add a,0x','',St,AsmText));
    $26 : AsmText:='add a,@r0';
    $27 : AsmText:='add a,@r1';
    $28 : AsmText:='add a,r0';
    $29 : AsmText:='add a,r1';
    $2A : AsmText:='add a,r2';
    $2B : AsmText:='add a,r3';
    $2C : AsmText:='add a,r4';
    $2D : AsmText:='add a,r5';
    $2E : AsmText:='add a,r6';
    $2F : AsmText:='add a,r7';
    $30 : inc(result,DecompileBitFunction2('jnb ',',',St,AsmText));
    $31 : inc(result,DecompileStdFunction('acall (0x1',')',St,AsmText));
    $32 : AsmText:='reti';
    $33 : AsmText:='rlc a';
    $34 : inc(result,DecompileStdFunction('addc a,#0x','',St,AsmText));
    $35 : inc(result,DecompileStdFunction('addc a,0x','',St,AsmText));
    $36 : AsmText:='addc a,@r0';
    $37 : AsmText:='addc a,@r1';
    $38 : AsmText:='addc a,r0';
    $39 : AsmText:='addc a,r1';
    $3A : AsmText:='addc a,r2';
    $3B : AsmText:='addc a,r3';
    $3C : AsmText:='addc a,r4';
    $3D : AsmText:='addc a,r5';
    $3E : AsmText:='addc a,r6';
    $3F : AsmText:='addc a,r7';
    $40 : begin inc(result); St.Read(B,1); AsmText:='jc '+GetRel(B); end;
    $41 : inc(result,DecompileStdFunction('ajmp (0x2',')',St,AsmText));
    $42 : inc(result,DecompileStdFunction('orl 0x',',a',St,AsmText));
    $43 : inc(result,DecompileStdFunction2('orl 0x',',#0x','',St,AsmText));
    $44 : inc(result,DecompileStdFunction('orl a,#0x','',St,AsmText));
    $45 : inc(result,DecompileStdFunction('orl a,0x','',St,AsmText));
    $46 : AsmText:='orl a,@r0';
    $47 : AsmText:='orl a,@r1';
    $48 : AsmText:='orl a,r0';
    $49 : AsmText:='orl a,r1';
    $4A : AsmText:='orl a,r2';
    $4B : AsmText:='orl a,r3';
    $4C : AsmText:='orl a,r4';
    $4D : AsmText:='orl a,r5';
    $4E : AsmText:='orl a,r6';
    $4F : AsmText:='orl a,r7';
    $50 : begin inc(result); St.Read(B,1); AsmText:='jnc '+GetRel(B); end;
    $51 : inc(result,DecompileStdFunction('acall (0x2',')',St,AsmText));
    $52 : inc(result,DecompileStdFunction('anl 0x',',a',St,AsmText));
    $53 : inc(result,DecompileStdFunction2('anl 0x',',#0x','',St,AsmText));
    $54 : inc(result,DecompileStdFunction('anl a,#0x','',St,AsmText));
    $55 : inc(result,DecompileStdFunction('anl a,0x','',St,AsmText));
    $56 : AsmText:='anl a,@r0';
    $57 : AsmText:='anl a,@r1';
    $58 : AsmText:='anl a,r0';
    $59 : AsmText:='anl a,r1';
    $5A : AsmText:='anl a,r2';
    $5B : AsmText:='anl a,r3';
    $5C : AsmText:='anl a,r4';
    $5D : AsmText:='anl a,r5';
    $5E : AsmText:='anl a,r6';
    $5F : AsmText:='anl a,r7';
    $60 : begin inc(result); St.Read(B,1); AsmText:='jz '+GetRel(B); end;
    $61 : inc(result,DecompileStdFunction('ajmp (0x3',')',St,AsmText));
    $62 : inc(result,DecompileStdFunction('xrl 0x',',a',St,AsmText));
    $63 : inc(result,DecompileStdFunction2('xrl 0x',',#0x','',St,AsmText));
    $64 : inc(result,DecompileStdFunction('xrl a,#0x','',St,AsmText));
    $65 : inc(result,DecompileStdFunction('xrl a,0x','',St,AsmText));
    $66 : AsmText:='xrl a,@r0';
    $67 : AsmText:='xrl a,@r1';
    $68 : AsmText:='xrl a,r0';
    $69 : AsmText:='xrl a,r1';
    $6A : AsmText:='xrl a,r2';
    $6B : AsmText:='xrl a,r3';
    $6C : AsmText:='xrl a,r4';
    $6D : AsmText:='xrl a,r5';
    $6E : AsmText:='xrl a,r6';
    $6F : AsmText:='xrl a,r7';
    $70 : begin inc(result); St.Read(B,1); AsmText:='jnz '+GetRel(B); end;
    $71 : inc(result,DecompileStdFunction('acall (0x3',')',St,AsmText));
    $72 : inc(result,DecompileBitFunction('orl c,','',St,AsmText));
    $73 : AsmText:='jmp @a+dptr';
    $74 : inc(result,DecompileStdFunction('mov a,#0x','',St,AsmText));
    $75 : inc(result,DecompileStdFunction2('mov 0x',',#0x','',St,AsmText));
    $76 : inc(result,DecompileStdFunction('mov @r0,#0x','',St,AsmText));
    $77 : inc(result,DecompileStdFunction('mov @r1,#0x','',St,AsmText));
    $78 : inc(result,DecompileStdFunction('mov r0,#0x','',St,AsmText));
    $79 : inc(result,DecompileStdFunction('mov r1,#0x','',St,AsmText));
    $7A : inc(result,DecompileStdFunction('mov r2,#0x','',St,AsmText));
    $7B : inc(result,DecompileStdFunction('mov r3,#0x','',St,AsmText));
    $7C : inc(result,DecompileStdFunction('mov r4,#0x','',St,AsmText));
    $7D : inc(result,DecompileStdFunction('mov r5,#0x','',St,AsmText));
    $7E : inc(result,DecompileStdFunction('mov r6,#0x','',St,AsmText));
    $7F : inc(result,DecompileStdFunction('mov r7,#0x','',St,AsmText));
    $80 : begin inc(result); St.Read(B,1); AsmText:='sjmp '+GetRel(B); end;
    $81 : inc(result,DecompileStdFunction('ajmp (0x4',')',St,AsmText));
    $82 : inc(result,DecompileBitFunction('anl c,','',St,AsmText));
    $83 : AsmText:='movc a,@a+pc';
    $84 : AsmText:='div ab';
    $85 : inc(result,DecompileStdFunction2('mov 0x',',0x','',St,AsmText));
    $86 : inc(result,DecompileStdFunction('mov 0x',',@r0',St,AsmText));
    $87 : inc(result,DecompileStdFunction('mov 0x',',@r1',St,AsmText));
    $88 : inc(result,DecompileStdFunction('mov 0x',',r0',St,AsmText));
    $89 : inc(result,DecompileStdFunction('mov 0x',',r1',St,AsmText));
    $8A : inc(result,DecompileStdFunction('mov 0x',',r2',St,AsmText));
    $8B : inc(result,DecompileStdFunction('mov 0x',',r3',St,AsmText));
    $8C : inc(result,DecompileStdFunction('mov 0x',',r4',St,AsmText));
    $8D : inc(result,DecompileStdFunction('mov 0x',',r5',St,AsmText));
    $8E : inc(result,DecompileStdFunction('mov 0x',',r6',St,AsmText));
    $8F : inc(result,DecompileStdFunction('mov 0x',',r7',St,AsmText));
    $90 : inc(result,DecompileLong('mov DPTR,#',St,AsmText));
    $91 : inc(result,DecompileStdFunction('acall (0x4',')',St,AsmText));
    $92 : inc(result,DecompileBitFunction('mov ',',c',St,AsmText));
    $93 : AsmText:='movc a,@a+dptr';
    $94 : inc(result,DecompileStdFunction('sub a,#0x','',St,AsmText));
    $95 : inc(result,DecompileStdFunction('sub a,0x','',St,AsmText));
    $96 : AsmText:='subb a,@r0';
    $97 : AsmText:='subb a,@r1';
    $98 : AsmText:='subb a,r0';
    $99 : AsmText:='subb a,r1';
    $9A : AsmText:='subb a,r2';
    $9B : AsmText:='subb a,r3';
    $9C : AsmText:='subb a,r4';
    $9D : AsmText:='subb a,r5';
    $9E : AsmText:='subb a,r6';
    $9F : AsmText:='subb a,r7';
    $A0 : inc(result,DecompileBitFunction('orl c,/','',St,AsmText));
    $A1 : inc(result,DecompileStdFunction('ajmp (0x5',')',St,AsmText));
    $A2 : inc(result,DecompileBitFunction('mov c,','',St,AsmText));
    $A3 : AsmText:='inc DPTR';
    $A4 : AsmText:='mul ab';
    {A5 nicht belegt}
    $A6 : inc(result,DecompileStdFunction('mov @r0,0x','',St,AsmText));
    $A7 : inc(result,DecompileStdFunction('mov @r0,0x','',St,AsmText));
    $A8 : inc(result,DecompileStdFunction('mov r0,0x','',St,AsmText));
    $A9 : inc(result,DecompileStdFunction('mov r1,0x','',St,AsmText));
    $AA : inc(result,DecompileStdFunction('mov r2,0x','',St,AsmText));
    $AB : inc(result,DecompileStdFunction('mov r3,0x','',St,AsmText));
    $AC : inc(result,DecompileStdFunction('mov r4,0x','',St,AsmText));
    $AD : inc(result,DecompileStdFunction('mov r5,0x','',St,AsmText));
    $AE : inc(result,DecompileStdFunction('mov r6,0x','',St,AsmText));
    $AF : inc(result,DecompileStdFunction('mov r7,0x','',St,AsmText));
    $B0 : inc(result,DecompileBitFunction('anl c,/','',St,AsmText));
    $B1 : inc(result,DecompileStdFunction('acall (0x5',')',St,AsmText));
    $B2 : inc(result,DecompileBitFunction('cpl ','',St,AsmText));
    $B3 : AsmText:='cpl c';
    $B4 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne a,0x'+IntToHex(B,2)+GetRel(C); end;
    $B5 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne a,#0x'+IntToHex(B,2)+GetRel(C); end;
    $B6 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne @r0,#0x'+IntToHex(B,2)+GetRel(C); end;
    $B7 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne @r1,#0x'+IntToHex(B,2)+GetRel(C); end;
    $B8 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r0,#0x'+IntToHex(B,2)+GetRel(C); end;
    $B9 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r1,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BA : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r2,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BB : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r3,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BC : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r4,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BD : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r5,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BE : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r6,#0x'+IntToHex(B,2)+GetRel(C); end;
    $BF : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='cjne r7,#0x'+IntToHex(B,2)+GetRel(C); end;
    $C0 : inc(result,DecompileStdFunction('push 0x','',St,AsmText));
    $C1 : inc(result,DecompileStdFunction('ajmp (0x6',')',St,AsmText));
    $C2 : inc(result,DecompileBitFunction('clr ','',St,AsmText));
    $C3 : AsmText:='clr c';
    $C4 : AsmText:='swap a';
    $C5 : inc(result,DecompileStdFunction('xch a,0x','',St,AsmText));
    $C6 : AsmText:='xch a,@r0';
    $C7 : AsmText:='xch a,@r1';
    $C8 : AsmText:='xch a,r0';
    $C9 : AsmText:='xch a,r1';
    $CA : AsmText:='xch a,r2';
    $CB : AsmText:='xch a,r3';
    $CC : AsmText:='xch a,r4';
    $CD : AsmText:='xch a,r5';
    $CE : AsmText:='xch a,r6';
    $CF : AsmText:='xch a,r7';
    $D0 : inc(result,DecompileStdFunction('pop 0x','',St,AsmText));
    $D1 : inc(result,DecompileStdFunction('acall (0x6',')',St,AsmText));
    $D2 : inc(result,DecompileBitFunction('setb ','',St,AsmText));
    $D3 : AsmText:='setb c';
    $D4 : AsmText:='da a';
    $D5 : begin inc(result,2); St.Read(B,1); St.Read(C,1); AsmText:='djnz 0x'+IntToHex(B,2)+','+GetRel(C); end;
    $D6 : AsmText:='xchd a,@r0';
    $D7 : AsmText:='xchd a,@r0';
    $D8 : begin inc(result); St.Read(B,1); AsmText:='djnz r0,'+GetRel(B); end;
    $D9 : begin inc(result); St.Read(B,1); AsmText:='djnz r1,'+GetRel(B); end;
    $DA : begin inc(result); St.Read(B,1); AsmText:='djnz r2,'+GetRel(B); end;
    $DB : begin inc(result); St.Read(B,1); AsmText:='djnz r3,'+GetRel(B); end;
    $DC : begin inc(result); St.Read(B,1); AsmText:='djnz r4,'+GetRel(B); end;
    $DD : begin inc(result); St.Read(B,1); AsmText:='djnz r5,'+GetRel(B); end;
    $DE : begin inc(result); St.Read(B,1); AsmText:='djnz r6,'+GetRel(B); end;
    $DF : begin inc(result); St.Read(B,1); AsmText:='djnz r7,'+GetRel(B); end;
    $E0 : AsmText:='movx a,@dptr';
    $E1 : inc(result,DecompileStdFunction('ajmp (0x7',')',St,AsmText));
    $E2 : AsmText:='movx a,@r0';
    $E3 : AsmText:='movx a,@r1';
    $E4 : AsmText:='clr a';
    $E5 : inc(result,DecompileStdFunction('mov a,0x','',St,AsmText));
    $E6 : AsmText:='mov a,@r0';
    $E7 : AsmText:='mov a,@r1';
    $E8 : AsmText:='mov a,r0';
    $E9 : AsmText:='mov a,r1';
    $EA : AsmText:='mov a,r2';
    $EB : AsmText:='mov a,r3';
    $EC : AsmText:='mov a,r4';
    $ED : AsmText:='mov a,r5';
    $EE : AsmText:='mov a,r6';
    $EF : AsmText:='mov a,r7';
    $F0 : AsmText:='movx @dptr,a';
    $F1 : inc(result,DecompileStdFunction('acall (0x7',')',St,AsmText));
    $F2 : AsmText:='movx @r0';
    $F3 : AsmText:='movx @r1';
    $F4 : AsmText:='cpl a';
    $F5 : inc(result,DecompileStdFunction('mov 0x',',a',St,AsmText));
    $F6 : AsmText:='mov @r0,a';
    $F7 : AsmText:='mov @r1,a';
    $F8 : AsmText:='mov r0,a';
    $F9 : AsmText:='mov r1,a';
    $FA : AsmText:='mov r2,a';
    $FB : AsmText:='mov r3,a';
    $FC : AsmText:='mov r4,a';
    $FD : AsmText:='mov r5,a';
    $FE : AsmText:='mov r6,a';
    $FF : AsmText:='mov r7,a';
    else AsmText:='ungltiger Opcode "0x'+IntToHex(B,2)+'"';
  end;
end;

Procedure DecodeSRec2(const St : TStrings);
Var Qu : TStrings;
    S : String;
    A,B : Integer;
    MSt : TMemoryStream;
begin
  Qu:=TStringlist.Create;
  Qu.Assign(St);
  try
    St.Clear; A:=0;
    while Qu.Count>0 do begin
      S:=Trim(Qu[0]); Qu.Delete(0);
      If (S='') or (S='lo') then continue;
      If (length(S)>1) and (S[1]='S') and (S[2]='1') then begin
        S:=Copy(S,5,MaxInt); Setlength(S,length(S)-2);
        B:=StrToInt('0x'+Copy(S,1,4));
        If A<>B then begin St.Add('.org 0x'+IntToHex(B,1)); A:=B; end;
        S:=Copy(S,5,MaxInt);
        MSt:=TMemoryStream.Create;
        while S<>'' do begin
          B:=StrToInt('0x'+Copy(S,1,2)); MSt.Write(B,1); S:=copy(S,3,MaxInt);
        end;
        MSt.Position:=0;
        while MSt.Position<MSt.Size do begin DecompileOp(MSt,S); St.Add(S); end;
      end;
    end;
  except
    St.Clear;
    St.Add('Es ist ein Fehler beim Auswerten des Codes aufgetreten.');
  end;
  Qu.Free;
end;

Function DecompilePrg(const St : TStream) : TStrings;
Var S : String;
begin
  result:=TStringlist.Create;
  result.LoadFromStream(St);
  If result[0]='lo' then begin
    DecodeSRec2(result);
  end else begin
    result.Clear;
    St.Position:=0;
    while St.Position<St.Size do begin DecompileOp(St,S); result.Add(S); end;
  end;
end;

end.
