unit InputDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TInputDialog = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure FormShow(Sender: TObject);
    procedure DoCalc(Sender: TObject);
  private
    { Private-Deklarationen }
    Max,Halb : Integer;
    Changing : Boolean;
    Procedure Error(E : TEdit);
  public
    { Public-Deklarationen }
    Bytes : Integer;
  end;

var
  InputDialog: TInputDialog;

Function InputNumber(Var I : Integer; Bytes : Integer) : Boolean;

implementation

uses Tools;

{$R *.DFM}

Function InputNumber(Var I : Integer; Bytes : Integer) : Boolean;
begin
  InputDialog:=TInputDialog.Create(Application.MainForm);
  try
    InputDialog.Edit2.Text:=IntToStr(I);
    InputDialog.Bytes:=Bytes;
    result:=(InputDialog.ShowModal=mrOK);
    If result then begin
      I:=StrToInt(Trim(InputDialog.Edit2.Text));
    end;
  finally
    InputDialog.Free;
  end;
end;

procedure TInputDialog.FormShow(Sender: TObject);
begin
  Case Bytes of
    1 : begin Caption:=Caption+' (8-Bit Zahl)'; Max:=255; end;
    2 : begin Caption:=Caption+' (16-Bit Zahl)'; Max:=65535; end;
  end;
  Halb:=Max div 2;
  Changing:=False;
  DoCalc(Edit2);
end;

procedure TInputDialog.DoCalc(Sender: TObject);
Var I,J : Integer;
    S : String;
begin
  If Changing then exit;
  I:=0;
  If Sender=Edit1 then begin
    S:=Trim(Edit1.Text);
    If Copy(S,1,2)<>'0x' then S:='0x'+S;
    try I:=StrToInt(S); except Error(Edit1); exit; end;
  end;
  If Sender=Edit2 then begin
    try I:=StrToInt(Edit2.Text); except Error(Edit2); exit; end;
  end;
  If Sender=Edit3 then begin
    If not BinToInt(Edit3.Text,I) then begin Error(Edit3); exit; end;
  end;
  If Sender=Edit4 then begin
    S:=Trim(Edit4.Text);
    If (S<>'') and (S[1]='-') then begin
      J:=-1; S:=Copy(S,2,MaxInt);
    end else J:=1;
    If Copy(S,1,2)<>'0x' then S:='0x'+S;
    try I:=J*StrToInt(S); except Error(Edit4); exit; end;
    If (I>Halb) or (I<-(Halb+1)) then begin Error(Edit4); exit; end;
    If I<0 then I:=ZweiKomplement(I,Bytes);
  end;
  If Sender=Edit5 then begin
    try I:=StrToInt(Edit5.Text); except Error(Edit5); exit; end;
    If (I>Halb) or (I<-(Halb+1)) then begin Error(Edit5); exit; end;
    If I<0 then I:=ZweiKomplement(I,Bytes);
  end;
  If (I<0) or (I>Max) then begin Error(Sender as TEdit); exit; end;

  Error(nil);
  Changing:=True;
  If Sender<>Edit1 then Edit1.Text:=IntToHex(I,1);
  If Sender<>Edit2 then Edit2.Text:=IntToStr(I);
  If Sender<>Edit3 then Edit3.Text:=IntToBin(I);
  I:=ZweiKomplementBack(I,Bytes);
  If Sender<>Edit4 then begin
    Edit4.Text:=IntToHex(Abs(I),1);
    If I<0 then Edit4.Text:='-'+Edit4.Text;
  end;
  If Sender<>Edit5 then Edit5.Text:=IntToStr(I);
  Changing:=False;
end;

procedure TInputDialog.Error(E : TEdit);
begin
  Changing:=True;
  If E<>nil then begin
    If E<>Edit1 then Edit1.Text:='';
    If E<>Edit2 then Edit2.Text:='';
    If E<>Edit3 then Edit3.Text:='';
    If E<>Edit4 then Edit4.Text:='';
    If E<>Edit5 then Edit5.Text:='';
    E.Font.Color:=clRed;
  end else begin
    Edit1.Font.Color:=clBlack;
    Edit2.Font.Color:=clBlack;
    Edit3.Font.Color:=clBlack;
    Edit4.Font.Color:=clBlack;
    Edit5.Font.Color:=clBlack;
  end;
  BitBtn1.Enabled:=(E=nil);
  Changing:=False;
end;

end.
