unit OutputDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ImgList, ToolWin, Menus;

type
  TOutputForm = class(TForm)
    ToolBar: TToolBar;
    ImageList: TImageList;
    Memo: TRichEdit;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    SaveDialog: TSaveDialog;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    PopupMenu: TPopupMenu;
    Anzeigen1: TMenuItem;
    SpeichernBinr1: TMenuItem;
    SpeichernText1: TMenuItem;
    SaveDialog2: TSaveDialog;
    Speichernsrec2Format1: TMenuItem;
    procedure ButtonWork(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PopupWork(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Procedure ReadData;
    Procedure SetupUpdate;
  end;

var
  OutputForm: TOutputForm = nil;

implementation

uses MainUnit, Tools;

{$R *.DFM}

procedure TOutputForm.ButtonWork(Sender: TObject);
Var P : TPoint;
begin
  Case (Sender as TToolButton).Tag of
    0 : Memo.Print('');
    1 : If SaveDialog.Execute then Memo.Lines.SaveToFile(SaveDialog.FileName);
    2 : begin
          P:=ClientToScreen(Point(ToolButton5.Left+5,ToolButton5.Top+ToolButton5.Height));
          PopupMenu.Popup(P.X,P.Y);
        end;
    3 : Close;
  end;
end;

procedure TOutputForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OutputForm:=nil;
  Action:=caFree;
end;

procedure TOutputForm.FormCreate(Sender: TObject);
begin
  ReadData;
  SetupUpdate;
  If MainForm.WindowStyle.ItemIndex>=0 then
    BoundsRect:=MainForm.SetupData.WindowSetup[MainForm.WindowStyle.ItemIndex].OutputWnd;
end;

Procedure TOutputForm.ReadData;
Var L : TStrings;
begin
  L:=MainForm.System8051.Programm.GetListing; Memo.Lines.Assign(L); L.Free;
end;

procedure TOutputForm.PopupWork(Sender: TObject);
Var St : TStream;
    FSt : TFileStream;
    Str, Str2 : TStrings;
    S : String;
begin
  Case (Sender as TMenuitem).Tag of
    0 : begin
          St:=MainForm.System8051.Programm.GetAsmCode(False);
          Memo.Lines.Add('');
          Memo.Lines.Add('Bytecode:');
          S:=BinToText(St); St.Free;
          while length(S)>50 do begin
            Memo.Lines.Add(Copy(S,1,50));
            S:=Copy(S,51,MaxInt);
          end;
          Memo.Lines.Add(S);
          Memo.Lines.Add('');
          Memo.Lines.Add('sRec2-Code:');
          Str:=MainForm.System8051.Programm.GetAsmCode2;
          Str2:=BinToSRec2(Str,MainForm.System8051.Programm.StartAddr);
          Memo.Lines.AddStrings(Str2);
          Str.Free; Str2.Free;
        end;
    1 : If SaveDialog2.Execute then begin
          St:=MainForm.System8051.Programm.GetAsmCode(False);
          FSt:=TFileStream.Create(SaveDialog2.FileName,fmCreate);
          FSt.CopyFrom(St,0);
          St.Free; FSt.Free;
        end;
    2 : If SaveDialog.Execute then begin
          Str:=MainForm.System8051.Programm.GetAsmCode2;
          Str2:=BinToSRec2(Str,MainForm.System8051.Programm.StartAddr);
          Str2.SaveToFile(SaveDialog.FileName);
          Str.Free; Str2.Free;
        end;
    3 : If SaveDialog.Execute then begin
          St:=MainForm.System8051.Programm.GetAsmCode(False);
          Str:=TStringlist.Create;
          Str.Add(BinToText(St));
          Str.SaveToFile(SaveDialog.FileName);
          Str.Free; St.Free;
        end;
  end;
end;

Procedure TOutputForm.SetupUpdate;
begin
  Memo.Font.Size:=MainForm.SetupData.FontSize;
end;

end.
